#include "StdAfx.h"
#include ".\imagescriptletplugin.h"
#include "SimpleImageShape.h"
#include "XMLUtil.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_IMAGE_NODE, CImageScriptletPlugin);
CImageScriptletPlugin::CImageScriptletPlugin(void)
{
}

CImageScriptletPlugin::~CImageScriptletPlugin(void)
{
}
BOOL CImageScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CSimpleImageShape* pImageShape = reinterpret_cast<CSimpleImageShape*>(pTarget);
		if (pImageShape == NULL)
		{
			return bSuccess;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			//*/
			pImageShape->SetImage(szValue);
			/*/
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				pImageShape->SetImage(pImage);				
			}
			//*/			
		}
	}
	return bSuccess;
}
CComponent* CImageScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CSimpleImageShape;

	return pComponent;
}
IImage* CImageScriptletPlugin::LoadImage(LPCTSTR pszcValue) 
{ 
	return Application::LoadImage(pszcValue);
	//return new ImageProxy(pszcValue);
}